version: '3.9'
services:
  db:
    image: postgres:15
    environment:
      POSTGRES_PASSWORD: my_pass
    volumes:
      - data-db:/var/lib/postgresql/data
    configs:
      - source: init-db
        target: /docker-entrypoint-initdb.d/init-db.sql
    networks:
      - my-net

    restart: always

  web-server:
    image: busybox
    ports:
      - "8080:8080"
    networks:
      - my-net
    secrets:
      - source: my-config
        target: /config/
    restart: on-failure
    depends_on:
      - db
    deploy:
      replicas: 1
      resources:
        limits:
          cpus: '1'
          memory: 512M
        reservations:
          cpus: '0.5'
          memory: 256M

volumes:
  data-db:

networks:
  my-net:

configs:
  init-db:
    external: true

secrets:
  my-config:
    file: ./application.yaml